import { JwtHelperService } from '@auth0/angular-jwt';
import { NgForage } from 'ngforage';
import { HttpService } from './http.service';
import { ApiEntity } from '../interfaces/api-entity';
export declare class AuthService {
    protected httpService: HttpService;
    protected storageService: NgForage;
    protected jwtHelper: JwtHelperService;
    protected user: any;
    constructor(httpService: HttpService, storageService: NgForage);
    getToken(): Promise<string>;
    setToken(token: string): Promise<string>;
    /**
     * Set current logged user
     */
    setUser(user: ApiEntity): Promise<void>;
    getUser(): Promise<any>;
    /**
     * Check if current user is authenticated
     */
    isAuthenticated(): Promise<boolean>;
    /**
     * Attempt to refresh token
     */
    refreshToken(): Promise<string>;
    /**
     * Clear all session variables
     */
    logout(): Promise<void>;
}
